<?php

namespace App|C\ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfECouponBook ArrayType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfECouponBook
 * @subpackage Arrays
 */
class ArrayOfECouponBook extends AbstractStructArrayBase
{
    /**
     * The ECouponBook
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \App|C\StructType\ECouponBook[]
     */
    public $ECouponBook;
    /**
     * Constructor method for ArrayOfECouponBook
     * @uses ArrayOfECouponBook::setECouponBook()
     * @param \App|C\StructType\ECouponBook[] $eCouponBook
     */
    public function __construct(array $eCouponBook = array())
    {
        $this
            ->setECouponBook($eCouponBook);
    }
    /**
     * Get ECouponBook value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \App|C\StructType\ECouponBook[]|null
     */
    public function getECouponBook()
    {
        return isset($this->ECouponBook) ? $this->ECouponBook : null;
    }
    /**
     * This method is responsible for validating the values passed to the setECouponBook method
     * This method is willingly generated in order to preserve the one-line inline validation within the setECouponBook method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateECouponBookForArrayConstraintsFromSetECouponBook(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfECouponBookECouponBookItem) {
            // validation for constraint: itemType
            if (!$arrayOfECouponBookECouponBookItem instanceof \App|C\StructType\ECouponBook) {
                $invalidValues[] = is_object($arrayOfECouponBookECouponBookItem) ? get_class($arrayOfECouponBookECouponBookItem) : sprintf('%s(%s)', gettype($arrayOfECouponBookECouponBookItem), var_export($arrayOfECouponBookECouponBookItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The ECouponBook property can only contain items of type \App|C\StructType\ECouponBook, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set ECouponBook value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \App|C\StructType\ECouponBook[] $eCouponBook
     * @return \App|C\ArrayType\ArrayOfECouponBook
     */
    public function setECouponBook(array $eCouponBook = array())
    {
        // validation for constraint: array
        if ('' !== ($eCouponBookArrayErrorMessage = self::validateECouponBookForArrayConstraintsFromSetECouponBook($eCouponBook))) {
            throw new \InvalidArgumentException($eCouponBookArrayErrorMessage, __LINE__);
        }
        if (is_null($eCouponBook) || (is_array($eCouponBook) && empty($eCouponBook))) {
            unset($this->ECouponBook);
        } else {
            $this->ECouponBook = $eCouponBook;
        }
        return $this;
    }
    /**
     * Add item to ECouponBook value
     * @throws \InvalidArgumentException
     * @param \App|C\StructType\ECouponBook $item
     * @return \App|C\ArrayType\ArrayOfECouponBook
     */
    public function addToECouponBook(\App|C\StructType\ECouponBook $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \App|C\StructType\ECouponBook) {
            throw new \InvalidArgumentException(sprintf('The ECouponBook property can only contain items of type \App|C\StructType\ECouponBook, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->ECouponBook[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \App|C\StructType\ECouponBook|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \App|C\StructType\ECouponBook|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \App|C\StructType\ECouponBook|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \App|C\StructType\ECouponBook|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \App|C\StructType\ECouponBook|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string ECouponBook
     */
    public function getAttributeName()
    {
        return 'ECouponBook';
    }
}
