<?php

namespace App|C\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for AbstractResponse StructType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:AbstractResponse
 * @subpackage Structs
 */
class AbstractResponse extends ApiObject
{
    /**
     * The ResponseInfo
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \App|C\StructType\ResponseInfo
     */
    public $ResponseInfo;
    /**
     * Constructor method for AbstractResponse
     * @uses AbstractResponse::setResponseInfo()
     * @param \App|C\StructType\ResponseInfo $responseInfo
     */
    public function __construct(\App|C\StructType\ResponseInfo $responseInfo = null)
    {
        $this
            ->setResponseInfo($responseInfo);
    }
    /**
     * Get ResponseInfo value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \App|C\StructType\ResponseInfo|null
     */
    public function getResponseInfo()
    {
        return isset($this->ResponseInfo) ? $this->ResponseInfo : null;
    }
    /**
     * Set ResponseInfo value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \App|C\StructType\ResponseInfo $responseInfo
     * @return \App|C\StructType\AbstractResponse
     */
    public function setResponseInfo(\App|C\StructType\ResponseInfo $responseInfo = null)
    {
        if (is_null($responseInfo) || (is_array($responseInfo) && empty($responseInfo))) {
            unset($this->ResponseInfo);
        } else {
            $this->ResponseInfo = $responseInfo;
        }
        return $this;
    }
}
