<?php

namespace App|C\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for EMDAbstractTicketFare StructType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:EMDAbstractTicketFare
 * @subpackage Structs
 */
class EMDAbstractTicketFare extends AbstractTicketFare
{
    /**
     * The AncillaryCode
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $AncillaryCode;
    /**
     * The AssociatedSpecialServiceCode
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $AssociatedSpecialServiceCode;
    /**
     * The CustomAncillaryData
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $CustomAncillaryData;
    /**
     * The HtmlDescription
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $HtmlDescription;
    /**
     * The Label
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $Label;
    /**
     * Constructor method for EMDAbstractTicketFare
     * @uses EMDAbstractTicketFare::setAncillaryCode()
     * @uses EMDAbstractTicketFare::setAssociatedSpecialServiceCode()
     * @uses EMDAbstractTicketFare::setCustomAncillaryData()
     * @uses EMDAbstractTicketFare::setHtmlDescription()
     * @uses EMDAbstractTicketFare::setLabel()
     * @param string $ancillaryCode
     * @param string $associatedSpecialServiceCode
     * @param string $customAncillaryData
     * @param string $htmlDescription
     * @param string $label
     */
    public function __construct($ancillaryCode = null, $associatedSpecialServiceCode = null, $customAncillaryData = null, $htmlDescription = null, $label = null)
    {
        $this
            ->setAncillaryCode($ancillaryCode)
            ->setAssociatedSpecialServiceCode($associatedSpecialServiceCode)
            ->setCustomAncillaryData($customAncillaryData)
            ->setHtmlDescription($htmlDescription)
            ->setLabel($label);
    }
    /**
     * Get AncillaryCode value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getAncillaryCode()
    {
        return isset($this->AncillaryCode) ? $this->AncillaryCode : null;
    }
    /**
     * Set AncillaryCode value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $ancillaryCode
     * @return \App|C\StructType\EMDAbstractTicketFare
     */
    public function setAncillaryCode($ancillaryCode = null)
    {
        // validation for constraint: string
        if (!is_null($ancillaryCode) && !is_string($ancillaryCode)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($ancillaryCode, true), gettype($ancillaryCode)), __LINE__);
        }
        if (is_null($ancillaryCode) || (is_array($ancillaryCode) && empty($ancillaryCode))) {
            unset($this->AncillaryCode);
        } else {
            $this->AncillaryCode = $ancillaryCode;
        }
        return $this;
    }
    /**
     * Get AssociatedSpecialServiceCode value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getAssociatedSpecialServiceCode()
    {
        return isset($this->AssociatedSpecialServiceCode) ? $this->AssociatedSpecialServiceCode : null;
    }
    /**
     * Set AssociatedSpecialServiceCode value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $associatedSpecialServiceCode
     * @return \App|C\StructType\EMDAbstractTicketFare
     */
    public function setAssociatedSpecialServiceCode($associatedSpecialServiceCode = null)
    {
        // validation for constraint: string
        if (!is_null($associatedSpecialServiceCode) && !is_string($associatedSpecialServiceCode)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($associatedSpecialServiceCode, true), gettype($associatedSpecialServiceCode)), __LINE__);
        }
        if (is_null($associatedSpecialServiceCode) || (is_array($associatedSpecialServiceCode) && empty($associatedSpecialServiceCode))) {
            unset($this->AssociatedSpecialServiceCode);
        } else {
            $this->AssociatedSpecialServiceCode = $associatedSpecialServiceCode;
        }
        return $this;
    }
    /**
     * Get CustomAncillaryData value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getCustomAncillaryData()
    {
        return isset($this->CustomAncillaryData) ? $this->CustomAncillaryData : null;
    }
    /**
     * Set CustomAncillaryData value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $customAncillaryData
     * @return \App|C\StructType\EMDAbstractTicketFare
     */
    public function setCustomAncillaryData($customAncillaryData = null)
    {
        // validation for constraint: string
        if (!is_null($customAncillaryData) && !is_string($customAncillaryData)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($customAncillaryData, true), gettype($customAncillaryData)), __LINE__);
        }
        if (is_null($customAncillaryData) || (is_array($customAncillaryData) && empty($customAncillaryData))) {
            unset($this->CustomAncillaryData);
        } else {
            $this->CustomAncillaryData = $customAncillaryData;
        }
        return $this;
    }
    /**
     * Get HtmlDescription value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getHtmlDescription()
    {
        return isset($this->HtmlDescription) ? $this->HtmlDescription : null;
    }
    /**
     * Set HtmlDescription value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $htmlDescription
     * @return \App|C\StructType\EMDAbstractTicketFare
     */
    public function setHtmlDescription($htmlDescription = null)
    {
        // validation for constraint: string
        if (!is_null($htmlDescription) && !is_string($htmlDescription)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($htmlDescription, true), gettype($htmlDescription)), __LINE__);
        }
        if (is_null($htmlDescription) || (is_array($htmlDescription) && empty($htmlDescription))) {
            unset($this->HtmlDescription);
        } else {
            $this->HtmlDescription = $htmlDescription;
        }
        return $this;
    }
    /**
     * Get Label value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getLabel()
    {
        return isset($this->Label) ? $this->Label : null;
    }
    /**
     * Set Label value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $label
     * @return \App|C\StructType\EMDAbstractTicketFare
     */
    public function setLabel($label = null)
    {
        // validation for constraint: string
        if (!is_null($label) && !is_string($label)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($label, true), gettype($label)), __LINE__);
        }
        if (is_null($label) || (is_array($label) && empty($label))) {
            unset($this->Label);
        } else {
            $this->Label = $label;
        }
        return $this;
    }
}
